https://leetcode.com/problems/max-area-of-island/description/
Approach #2: Depth-First Search (Iterative)
https://leetcode.com/problems/max-area-of-island/discuss/108575/My-BFS-solution-in-Java
https://leetcode.com/problems/max-area-of-island/discuss/186891/Java.-BFSDFSUnion-Find.
X. Union Find
https://leetcode.com/problems/max-area-of-island/discuss/167644/Union-Find
Given a non-empty 2D array
grid
of 0's and 1's, an island is a group of 1
's (representing land) connected 4-directionally (horizontal or vertical.) You may assume all four edges of the grid are surrounded by water.
Find the maximum area of an island in the given 2D array. (If there is no island, the maximum area is 0.)
Example 1:
[[0,0,1,0,0,0,0,1,0,0,0,0,0], [0,0,0,0,0,0,0,1,1,1,0,0,0], [0,1,1,0,1,0,0,0,0,0,0,0,0], [0,1,0,0,1,1,0,0,1,0,1,0,0], [0,1,0,0,1,1,0,0,1,1,1,0,0], [0,0,0,0,0,0,0,0,0,0,1,0,0], [0,0,0,0,0,0,0,1,1,1,0,0,0], [0,0,0,0,0,0,0,1,1,0,0,0,0]]Given the above grid, return
6
. Note the answer is not 11, because the island must be connected 4-directionally.
Example 2:
[[0,0,0,0,0,0,0,0]]Given the above grid, return
0
.
Note: The length of each dimension in the given
grid
does not exceed 50.
int[][] grid;
boolean[][] seen;
public int area(int r, int c) {
if (r < 0 || r >= grid.length || c < 0 || c >= grid[0].length || seen[r][c] || grid[r][c] == 0)
return 0;
seen[r][c] = true;
return (1 + area(r + 1, c) + area(r - 1, c) + area(r, c - 1) + area(r, c + 1));
}
public int maxAreaOfIsland(int[][] grid) {
this.grid = grid;
seen = new boolean[grid.length][grid[0].length];
int ans = 0;
for (int r = 0; r < grid.length; r++) {
for (int c = 0; c < grid[0].length; c++) {
ans = Math.max(ans, area(r, c));
}
}
return ans;
}
Intuition and Algorithm
We can try the same approach using a stack based, (or "iterative") depth-first search.
Here,
seen
will represent squares that have either been visited or are added to our list of squares to visit (stack
). For every starting land square that hasn't been visited, we will explore 4-directionally around it, adding land squares that haven't been added to seen
to our stack
.
On the side, we'll keep a count
shape
of the total number of squares seen during the exploration of this shape. We'll want the running max of these counts.
public int maxAreaOfIsland(int[][] grid) {
boolean[][] seen = new boolean[grid.length][grid[0].length];
int[] dr = new int[] { 1, -1, 0, 0 };
int[] dc = new int[] { 0, 0, 1, -1 };
int ans = 0;
for (int r0 = 0; r0 < grid.length; r0++) {
for (int c0 = 0; c0 < grid[0].length; c0++) {
if (grid[r0][c0] == 1 && !seen[r0][c0]) {
int shape = 0;
Stack<int[]> stack = new Stack();
stack.push(new int[] { r0, c0 });
seen[r0][c0] = true;
while (!stack.empty()) {
int[] node = stack.pop();
int r = node[0], c = node[1];
shape++;
for (int k = 0; k < 4; k++) {
int nr = r + dr[k];
int nc = c + dc[k];
if (0 <= nr && nr < grid.length && 0 <= nc && nc < grid[0].length && grid[nr][nc] == 1 && !seen[nr][nc]) {
stack.push(new int[] { nr, nc });
seen[nr][nc] = true;
}
}
}
ans = Math.max(ans, shape);
}
}
}
return ans;
}
public int maxAreaOfIsland(int[][] grid) {
if (grid == null)
return 0;
// change visited 1 to -1
int max = 0;
for (int i = 0; i < grid.length; i++) {
for (int j = 0; j < grid[0].length; j++) {
if (grid[i][j] == 1) {
max = Math.max(max, dfs(grid, i, j));
}
}
}
return max;
}
private int dfs(int[][] grid, int i, int j) {
if (i < 0 || i >= grid.length || j < 0 || j >= grid[0].length || grid[i][j] != 1)
return 0;
int count = 1;
grid[i][j] = -1;
count += dfs(grid, i + 1, j);
count += dfs(grid, i - 1, j);
count += dfs(grid, i, j + 1);
count += dfs(grid, i, j - 1);
return count;
}
X. BFShttps://leetcode.com/problems/max-area-of-island/discuss/108575/My-BFS-solution-in-Java
https://leetcode.com/problems/max-area-of-island/discuss/186891/Java.-BFSDFSUnion-Find.
public int maxAreaOfIsland(int[][] grid) {
if (grid == null || grid.length == 0 || grid[0].length == 0) return 0;
int M = grid.length;
int N = grid[0].length;
boolean[][] visited = new boolean[M][N];
int res = 0;
for (int i=0; i<M; i++) {
for (int j=0; j<N; j++) {
if (grid[i][j] == 1 && !visited[i][j]) {
res = Math.max(res, bfs(grid, visited, i, j));
}
}
}
return res;
}
private int bfs(int[][] grid, boolean[][] visited, int i, int j) {
Queue<int[]> q = new LinkedList<>();
q.add(new int[]{i, j});
visited[i][j] = true;
int res = 0;
while (!q.isEmpty()) {
int[] curr = q.poll();
res++;
for (int[] dir: DIRECTIONS) {
int x = curr[0] + dir[0];
int y = curr[1] + dir[1];
if (x < 0 || y < 0 || x >= grid.length || y >= grid[0].length || visited[x][y] || grid[x][y] != 1) continue;
q.add(new int[]{x, y});
visited[x][y] = true;
}
}
return res;
}
X. Union Find
https://leetcode.com/problems/max-area-of-island/discuss/167644/Union-Find
public int maxAreaOfIsland(int[][] grid) {
if(grid==null || grid.length==0 || grid[0].length==0){return 0;}
int m=grid.length, n=grid[0].length, maxSize=0;
boolean firstTime=true;
UF uf=new UF(m*n);
for(int i=0; i<m; i++){
for(int j=0; j<n; j++){
if(grid[i][j]==1){
if(firstTime){
uf.maxSize=1;
firstTime=false;
}
if(i+1<m && grid[i+1][j]==1){uf.union(i*n+j, (i+1)*n+j);}
if(j+1<n && grid[i][j+1]==1){uf.union(i*n+j, i*n+j+1);}
}
}
}
return uf.maxSize;
}
class UF{
private int[] arr;
private int[] size;
public int maxSize;
public UF(int n){
arr=new int[n];
size=new int[n];
maxSize=0;
for(int i=0; i<n; i++){
arr[i]=i;
size[i]=1;
}
}
public int root(int i){
while(i!=arr[i]){
i=arr[i];
}
return arr[i];
}
public boolean connected(int i, int j){
return root(i)==root(j);
}
public void union(int i, int j){
int rooti=root(i);
int rootj=root(j);
if(rooti==rootj){return;}
if(size[rooti]>size[rootj]){
arr[rootj]=rooti;
size[rooti]+=size[rootj];
maxSize=Math.max(maxSize, size[rooti]);
}else{
arr[rooti]=rootj;
size[rootj]+=size[rooti];
maxSize=Math.max(maxSize, size[rootj]);
}
}
}